## 2.1.0

* Do a health check of the http2-connection before making request.
* Introduce `ChannelOptions.connectionLimit` the longest time a single connection is used for new
  requests.
* Use Tcp.nodelay to improve client call speed.
* Use SecureSocket supportedProtocols to save a round trip when establishing a secure connection.
* Allow passing http2 `ServerSettings` to `Server.serve`.

## 2.0.3

* GrpcError now implements Exception to indicate it can be reasonably handled.

## 2.0.2

* Fix computation of the audience given to metadata providers to include the scheme.

## 2.0.1

* Fix computation of authority. This should fix authorization.

## 2.0.0+1

* Fix imports to ensure grpc-web.dart has no accidental transitive dependencies on dart:io.

## 2.0.0

* Add initial support for grpc-web.
  See `example/grpc-web` for an example of this working.
* **Breaking**: `grpc.dart` no longer exposes `ClientConnection`. It was supposed to be an internal
  abstraction.
* **Breaking**: `grpc.dart` no longer exposes the deprecated `ServerHandler`.
  It was supposed to be an internal abstraction.
* `service_api.dart` no longer exports Server - it has never been used by the generated code.

## 1.0.3

* Allow custom user agent with a `userAgent` argument for `ChannelOptions()`.
* Allow specifying `authority` for `ChannelCredentials.insecure()`.
* Add `userAgent` as an optional named argument for `clientConnection.createCallHeaders()`.

## 1.0.2

* Fix bug where the server would crash if the client would break the connection.

## 1.0.1

* Add `service_api.dart` that only contains the minimal imports needed by the code generated by
  protoc_plugin.

## 1.0.0+1

* Support package:http2  1.0.0.

## 1.0.0

* Graduate package to 1.0.

## 0.6.8+1

* Removes stray files that where published by accident in version 0.6.8.

## 0.6.8

* Calling `terminate()` or `shutdown()` on a channel doesn't throw error if the
channel is not yet open.

## 0.6.7

* Support package:test 1.5.

## 0.6.6

* Support `package:http` `>=0.11.3+17 <0.13.0`.
* Update `package:googleapis_auth` to `^0.2.5+3`.

## 0.6.5

* Interceptors are now async.

## 0.6.4

* Update dependencies to be compatible with Dart 2.

## 0.6.3

* Make fields of `StatusCode` const rather than final.

## 0.6.2

* Allow for non-ascii header values.

## 0.6.1

* More fixes to update to Dart 2 core library APIs.

## 0.6.0+1

* Updated implementation to use new Dart 2 APIs using
[dart2_fix](https://github.com/dart-lang/dart2_fix).

## 0.6.0

* Dart SDK upper constraint raised to declare compatability with Dart 2.0 stable.

## 0.5.0

* Breaking change: The package now exclusively supports Dart 2.
* Fixed tests to pass in Dart 2.
* Added support for Interceptors ([issue #79](https://github.com/grpc/grpc-dart/issues/79)); thanks to [@mogol](https://github.com/mogol) for contributing!

## 0.4.1

* Fixes for supporting Dart 2.

## 0.4.0

* Moved TLS credentials for server into a separate class.
* Added support for specifying the address for the server, and support for
  serving on an ephemeral port.

## 0.3.1

* Split out TLS credentials to a separate class.

## 0.3.0

* Added authentication metadata providers, optimized for use with Google Cloud.
* Added service URI to metadata provider API, needed for Json Web Token generation.
* Added authenticated cloud-to-prod interoperability tests.
* Refactored connection logic to throw initial connection errors early.

## 0.2.1

* Updated generated code in examples using latest protoc compiler plugin.
* Dart 2.0 fixes.
* Changed license to Apache 2.0.

## 0.2.0

* Implemented support for per-RPC metadata providers. This can be used for
  authentication providers which may need to obtain or refresh a token before
  the RPC is sent.

## 0.1.0

* Core gRPC functionality is implemented and passes
[gRPC compliance tests](https://github.com/grpc/grpc/blob/master/doc/interop-test-descriptions.md).

The API is shaping up, but may still change as more advanced features are implemented.

## 0.0.1

* Initial version.

This package is in a very early and experimental state. We do not recommend
using it for anything but experiments.
